﻿using Eingabeverwaltung.Metamodell;
using System.Collections.Immutable;

namespace Bewertung
{
    /// <summary>
    /// This is the readOnly result of assessment
    /// </summary>
    public class AssessmentResult : IAssessmentResult
    {
        public readonly SingleTask task;
        public readonly double assessment;
        public readonly ImmutableList<InductionPartAssessment> confIndAssessment;

        public AssessmentResult(SingleTask task, double assessment, ImmutableList<InductionPartAssessment> confIndAssessment)
        {
            this.task = task;
            this.assessment = assessment;
            this.confIndAssessment = confIndAssessment;
        }

        /// <summary>
        /// Returns the maximum points of the single Task and the configured induction parts of its main proof
        /// </summary>
        /// <returns></returns>
        public int MaxPt() => task.config.MaxPt();
        public double Assessment() => assessment;
    }
}
