﻿using Eingabeverwaltung.Metamodell;
using System;
using System.Collections.Generic;

namespace Ueberpruefung.CheckTransformation
{
    public class CheckSubstitution_for_RuleStartTree : ElementChecker
    {
        public CheckSubstitution_for_RuleStartTree() { }

        public override bool check(Element e)
        {
            if (e is TransformationStep ts)
            { 
                bool s = new CheckTermPart_match_RuleStartTree().check(ts),
                r = ts.termPart.Equals(CheckHelper.substitute(ts.ruleStartTree(), ts.substitutions));
                if (s && !r)
                {
                    Error err = new Error(9);
                    err.Output = Util.ListSubstitutionToString(CheckHelper.findSubstitution(ts.ruleStartTree(), ts.termPart));
                    ts.errors.Add(err);
                }
                return !s || r;
            }
            else throw new InvalidOperationException();
        }
    }
}